/*     Bed a menu-driven multi dataformat binary editor for Linux            */
/*     Copyright (C) 1998 Jaap Korthals Altes <jkaltes@cyberbrain.com>       */
/*                                                                           */
/*     This program is free software; you can redistribute it and/or modify  */
/*     it under the terms of the GNU General Public License as published by  */
/*     the Free Software Foundation; either version 2 of the License, or     */
/*     (at your option) any later version.                                   */
/*                                                                           */
/*     This program is distributed in the hope that it will be useful,       */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*     GNU General Public License for more details.                          */
/*                                                                           */
/*     You should have received a copy of the GNU General Public License     */
/*     along with this program; if not, write to the Free Software           */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             */
/* Fri Dec  8 22:14:27 2000                                                  */
#include "global.h"
BEDPLUGIN
#include <stdio.h>
#include <limits.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../offtypes.h"
#include "symtable.h"
class Symtable;
class Editor {
public:
#include "faked.h"

iscalled(symtable)
int Editor::getsymposition(int &length, int &startpos) ;
int Editor::startsymtable(Filter * (*func)(int fb,int sb,char *opts,ScreenPart *part=NULL)) ;
};
#define min(x,y) ((x)<(y)?(x):(y))
	Symtable::Symtable(int fbytes,int sbytes,int off=0,int len=LONG_MAX): tableoffset(off), 	maxintable(len),Filter(fbytes,sbytes) {
	
		label=name=filtername(Symtable);
		}
	Symtable::Symtable(int fb,int sb,char *conv) : Filter(fb,sb) {
		label=name=filtername(Symtable);
		if(conv)
			sscanf(conv,"%d-%d",&tableoffset,&maxintable);
		}
	Symtable::Symtable(Symtable &rev): Filter(rev) {
		label=rev.label;
		tableoffset=rev.tableoffset;
		maxintable=rev.maxintable;
		edit=rev.edit;
		}
	int Symtable::setpart(ScreenPart *p) {
		Filter::setpart(p);
		edit=p->editor;
		if(maxintable==LONG_MAX)
			maxintable=edit->filesize()-tableoffset;
		}
	char *Symtable::convstr(void) {
	#define convmax 80
		static char *conv=new char[convmax];
		snprintf(conv,convmax,"%d-%d",tableoffset,maxintable);
		return conv;
		}
	Symtable::~Symtable() {
		}
	 Filter *Symtable::newone(void) {
		return new Symtable(*this);
		}
	 int Symtable::chbytes(int b) {
		edit=part->editor;
		bytesfile=b;
		return bytesscreen;
		}
	 int Symtable::chbytesback(int b) {
		edit=part->editor;
		bytesscreen=b;
		err=0;
		return bytesfile;
		}
#define min(x,y) ((x)<(y)?(x):(y))
	 int Symtable::fromfile(unsigned char *input,unsigned char *output) {
		if(edit) {
			unsigned long intable=*((unsigned long*)input);
			char tmp[bytesscreen+1]; 
			memset(output,' ',bytesscreen);
			if(intable>=0&&intable<maxintable) {
				edit->getmem(	tableoffset +intable,(char *)tmp,bytesscreen);
				int len=min(strlen(tmp),bytesscreen);
				memcpy((char *)output,tmp,len);
				}
			}
		return bytesscreen;
		}
	 int Symtable::tofile(unsigned char *input,unsigned char *output) {
/* How do you know if it was intented to endup in the file instead of for
some other purpose like search 
		if(edit) {
			unsigned long intable=*((unsigned long*)output);
			if(intable>=0&&intable<maxintable) {
				int len=strcspn((char *)input," ");
				edit->putmem(	tableoffset +intable,(char *)input,min(bytesscreen,len));
				}
			}
*/

		return bytesfile;
		}
	int  Symtable::equal(Filter *fil) {
		if(!Filter::equal(fil))
			return 0;
		if(tableoffset!=((Symtable *)fil)->tableoffset)
			return 0;
		if(maxintable!=((Symtable *)fil)->maxintable)
			return 0;
		if(edit!=((Symtable *)fil)->edit)
			return 0;
		return 1;
		}

registerfilterclass(Symtable) 



#include "../screen.h"
#include "../getfile.h"
int Editor::symtable(void) {
	ScreenPart *super=activemode(),*act;
	act=super->getsubpart();
	char offset[50]="";
	char length[50]="";
	Symtable *ad=NULL;
for(int i=act->firstfilter;i<act->lastfilter;i++) {
	if(act->filters[i]->name==filtername(Symtable)) {
		ad=(Symtable*)act->filters[i];
		sprintf(offset,"%d",ad->tableoffset);
		sprintf(length,"%d",ad->maxintable);
		break;
		}
	}
int res=0;

  begindialog(9,30,5);
    mvwaddstr(takescr,1,2,"Symbols at");
    linernrmax("Off~set",offset,3,2,17,50);
    linernrmax("~Length",length,5,2,17,50);
    oke(7,2);
    act("~Cancel",7,10);
  enddialog(res,res);
filesup();
switch(res) {
	case 0:;
	case 4: 
		return -1;
	}
	unsigned long taboff=strtol(offset,NULL,0);
	unsigned long tablen=strtol(length,NULL,0);
	if(ad) {
			
		ad->tableoffset=taboff;
		ad->maxintable=tablen;
		}
	else  {
		ad=new Symtable(4,20,taboff,tablen);
		if(ad->error()) {
			delete ad;
			message("Error adding add");
			return -1;
			}
		addfilter(ad);
		}
	modechanged();
	super->calcsizes();
	toscreen();	
	return 0;
	}


call(symtable)

/*
extern char *filtername(Section) ;
static char sectionnul[1]="";
class Section: public Symtable {
	public:	
	int setpart(ScreenPart *p) {
		Filter::setpart(p);
		edit=p->editor;
		tableoffset=edit->getsymposition(maxintable);
		}

	Section(int fb,int sb,char *conv=NULL,ScreenPart *p=NULL) : Symtable(fb,sb) {
		label=name=filtername(Section);
		if(part) {
			Filter::setpart(p);
			edit=part->editor;
			tableoffset=edit->getsymposition(maxintable);
			}
		else
			maxintable==LONG_MAX;
		}
	Section(Symtable &rev): Symtable(rev) {
		label=rev.label;
		maxintable==LONG_MAX;
		}
	char *convstr(void) {
		return sectionnul;
		}
	};
*/
int Editor::startsymtable(Filter *(*func)(int fb,int sb,char *opts,ScreenPart *part=NULL)) {
	ScreenPart *super=activemode(),*act;
	act=super->getsubpart();
	Filter *ad=func(4,15,"",act);
	if(ad->error()) {
		delete ad;
		message("Error adding add");
		return -1;
		}
	addfilter(ad);
	act->screenbytes(ad->bytesscreen);
	toscreen();	
	}



